(* Title:  MathEngBasic/calc-tree-elem.sml
   Author: Walther Neuper 191026
   (c) due to copyright terms
*)
signature CALC_TREE_ELEMENT =
sig
  type fmz
  type fmz_
  val e_fmz : fmz_ * References_Def.T
  type result
\<^isac_test>\<open>
  val res2str : term * term list -> string
\<close>

  datatype safe = Sundef | Safe | Unsafe | Helpless_;
  val safe2str: safe -> string
end

(**)                   
structure Celem(**): CALC_TREE_ELEMENT(**) =
struct
(**)

type fmz_ = TermC.as_string list;
(* a formalization of an example contains data 
   sufficient for mechanically finding the solution for the example.
   FIXME.WN051014: dont store fmz = (_,spec) in the PblObj, this is done in origin *)
type fmz = fmz_ * References_Def.T;
val e_fmz = ([], References_Def.empty);

type result = term * term list
\<^isac_test>\<open>
fun res2str (t, ts) = pair2str (UnparseC.term t, UnparseC.terms ts);
\<close>

datatype safe = Sundef | Safe | Unsafe | Helpless_;
fun safe2str Sundef   = "Sundef"
  | safe2str Safe     = "Safe"
  | safe2str Unsafe   = "Unsafe" 
  | safe2str Helpless_ = "Helpless_";

(**)end(**);
