(* Title:  700-interSteps.sml
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.
*)
open Pos
open Ctree
open Solve
open Tactic
open LI
open Istate
open TermC
open Test_Code;
(*
  ATTENTION: nested "step into", use ML "--- step into XXXXX ---" from Test_*.thy
  for Sidekick in order to get levels of "step into" right.
*)

"----------- Minisubplb/700-interSteps.sml -----------------------";
"----------- Minisubplb/700-interSteps.sml -----------------------";
"----------- Minisubplb/700-interSteps.sml -----------------------";
(** adaption from rewtools.sml --- initContext..Ptool.Thy_, fun context_thm ---,
  *into a functional representation, i.e. we outcomment statements with side-effects:
 ** States.reset ();
 ** CalcTree @{context} [(["equality (x+1=(2::real))", "solveFor x", "solutions L"], 
 **   ("Test", ["sqroot-test", "univariate", "equation", "test"],
 **    ["Test", "squ-equ-test-subpbl1"]))];
 ** Iterator 1; moveActiveRoot 1;
 ** autoCalculate 1 CompleteCalc;
 **)
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(["equality (x+1=(2::real))", "solveFor x", "solutions L"],
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = ("Subproblem"*)
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;

(*+*)if p = ([], Res)
(*+*)then case nxt of End_Proof' => ()
(*+*)  | _ => error "calculation not finished correctly 1"
(*+*)else error "calculation not finished correctly 2";
(*+*)Test_Tool.show_pt pt; (* 11 lines with subpbl *)

(** val p = ([], Res);
 ** initContext 1 Ptool.Thy_ p
 ***  = <MESSAGE><CALCID>1</CALCID><STRING>no thy-context at result</STRING></MESSAGE>: XML.tree;
 ** val ((pt,_),_) = States.get_calc 1;  (* 11 lines with subpbl *)
 **
 ** interSteps 1 ([2], Res); (* added [2,1]..[2,6] *)
 **)
"~~~~~ fun interSteps, args:"; val (cI, ip) = (1, ([2], Res));
(** val ((pt, p), tacis) = States.get_calc cI;*)
val ip' = lev_pred' pt ip;

(*+*)ip = ([2], Res);
(*+*)ip' = ([1], Res);
(*+*)Test_Tool.show_pt pt;                (* 11 lines, as produced by autoCalculate CompleteCalc *)

val ("detailrls", pt''''', _) = (*case*) 
Detail_Step.go pt ip (*of*);

(*+*)Test_Tool.show_pt pt''''';                  (* added [2,1]..[2,6] after ([1], Res)*)

(*//------------------ step into Detail_Step.go --------------------------------------------\\*)
"~~~~~ fun go , args:"; val (pt, (pos as (p, _))) = (pt, ip);
(*+*)p = [2];
(*+*)pos = ([2], Res);

    val nd = Ctree.get_nd pt p
    val cn = Ctree.children nd
;
    (*if*) null cn (*then*);
      (*if*) (Tactic.is_rewset o (Ctree.get_obj Ctree.g_tac nd)) [(*root of nd*)] (*then*);

     Detail_Step.detailrls pt pos;
"~~~~~ fun detailrls , args:"; val (pt, (pos as (p, _))) = (pt, pos);
    val t = get_obj g_form pt p
	  val tac = get_obj g_tac pt p
    val ctxt = get_ctxt pt pos
	  val rls = tac |> Tactic.rls_of |> get_rls ctxt
    val xxx = (*case*) rls (*of*);
        val is = Istate.init_detail ctxt tac t

(*+*)val Rule_Set.Repeat {program = EmptyProg, ...} = rls; (*this prog is replaced by Auto_Prog.gen on the fly*)

        val is = Istate.init_detail ctxt tac t
	      val tac_ = Tactic.Apply_Method' (MethodC.id_empty(*WN0402: see generate1 !?!*), SOME t, is, ctxt)
	      val pos' = ((lev_on o lev_dn) p, Frm)
	      val (_, _, _, pt') = Step.add tac_ (is, ctxt) (pt, pos') (* implicit Take *);

	   (** )val (_,_, (pt'', _)) =( **)
           complete_solve CompleteSubpbl [] (pt', pos');
"~~~~~ fun complete_solve , args:"; val (auto, c, (ptp as (_, p as (_, p_))))
  = (CompleteSubpbl, [], (pt', pos'));
    (*if*) p = ([], Res) (*else*);
      (*if*) member op = [Pbl,Met] p_ (*else*);

   val (aaa, ([(Rewrite ("radd_commute", bbb), ccc, ddd)], c', ptp')) =
      (*case*) Step_Solve.do_next ptp (*of*);
(*keep for continuing complete_solve after do_next*)
(*+*)val continue_complete_solve = (aaa, ([(Rewrite ("radd_commute", bbb), ccc, ddd)], c', ptp'));
(*///----------------- step into do_next --------------------------------------------------\\\*)
"~~~~~ fun do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (ptp);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val ((ist, ctxt), sc) = LItool.resume_prog pos pt;

  (*case*) find_next_step sc ptp ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Pstate ist), ctxt) =
  (sc, ptp, ist, ctxt);

  (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...}))) =
  ((prog, (ptp, ctxt)), (Pstate ist));
  (*if*) path = [] (*then*);

           scan_dn cc (trans_scan_dn ist) (Program.body_of prog);
"~~~~~ fun scan_dn , args:"; val (cc, ist, (Const (\<^const_name>\<open>Tactical.Repeat\<close>(*2*), _) $ e)) =
  (cc, (trans_scan_dn ist), (Program.body_of prog));

           scan_dn cc (ist |> path_down [R]) e;
"~~~~~ fun scan_dn , args:"; val (cc, ist, (Const (\<^const_name>\<open>Tactical.Chain\<close>(*1*), _) $ e1 $ e2 $ a)) =
  (cc, (ist |> path_down [R]), e);

  (*case*) scan_dn cc (ist |> path_down_form ([L, L, R], a)) e1 (*of*);
"~~~~~ fun scan_dn , args:"; val (cc, (ist as {act_arg, ...}), (Const (\<^const_name>\<open>Tactical.Try\<close>(*2*), _) $ e)) =
  (cc, (ist |> path_down_form ([L, L, R], a)), e1);

  (*case*) scan_dn cc (ist |> path_down [R]) e (*of*);
"~~~~~ fun scan_dn , args:"; val (cc, ist, (Const (\<^const_name>\<open>Tactical.Repeat\<close>(*1*), _) $ e)) =
  (cc, (ist |> path_down [R]), e);

           scan_dn cc (ist |> path_down_form ([L, R], a)) e;
"~~~~~ fun scan_dn , args:"; val ((cc as (_, ctxt)), (ist as {eval, ...}), t (*fall-through*)) =
  (cc, (ist |> path_down_form ([L, R], a)), e);
        (*if*) Tactical.contained_in t (*else*);
val (Program.Tac prog_tac, form_arg) =
      (*case*) LItool.check_leaf "next  " ctxt eval (get_subst ist) t (*of*);

           check_tac cc ist (prog_tac, form_arg);
"~~~~~ fun check_tac , args:"; val (((pt, p), ctxt), ist, (prog_tac, form_arg)) =
  (cc, ist, (prog_tac, form_arg));
    val m = LItool.tac_from_prog (pt, p) prog_tac
val _ =
    (*case*) m (*of*);

      (*case*)
Solve_Step.check m (pt, p) (*of*);
"~~~~~ fun check , args:"; val ((Tactic.Rewrite thm), (cs as (pt, pos as (p, _)))) =
  (m, (pt, p));
(*-------------------- stop step into do_next ------------------------------------------------*)
(*\\\----------------- step into do_next --------------------------------------------------///*)

(*kept for continuing complete_solve after do_next*)
   val (_, ([(Rewrite ("radd_commute", _), _, _)], c', ptp')) = continue_complete_solve;

(*+*)val [([2], Res), ([3], Pbl), ([3, 1], Frm), ([3, 1], Res), ([3, 2], Res), ([3], Res),
(*+*)  ([4], Res), ([], Res)] = c';
(*+*)Test_Tool.show_pt (fst ptp');(*[
(([], Frm), solve (x + 1 = 2, x)),
(([1], Frm), x + 1 = 2),
(([1], Res), x + 1 + - 1 * 2 = 0),
(([2,1], Frm), x + 1 + - 1 * 2 = 0),
(([2,1], Res), 1 + x + - 1 * 2 = 0)]*)

	   (** )val (_, c', ptp') =( **)
           complete_solve auto (c @ c') ptp';
"~~~~~ fun complete_solve , args:"; val (auto, c, (ptp as (_, p as (_, p_))))
  = (auto, (c @ c'), ptp');
    (*if*) p = ([], Res) (*else*);
      (*if*) member op = [Pbl,Met] p_ (*else*);

val (_, ([(Rewrite ("add.assoc", _), _, _)], c', ptp')) = (*case*) Step_Solve.do_next ptp (*of*);
(*???*)
"~~~~~ fun complete_solve , args:"; val (auto, c, (ptp as (_, p as (_, p_))))
  = (auto, (c @ c'), ptp');
    (*if*) p = ([], Res) (*else*);
      (*if*) member op = [Pbl,Met] p_ (*else*);
   val (_, ([(Calculate "TIMES", _, _)], c', ptp')) = (*case*)Step_Solve.do_next ptp (*of*);

Test_Tool.show_pt (fst ptp');          (* added  [2,1]..[2,3], more to come *)
(*-------------------- stop step into Detail_Step.go -----------------------------------------*)
(*\\------------------ step into Detail_Step.go --------------------------------------------//*)

(**
 ** interSteps 1 ([3,1], Res);
 **)
"~~~~~ fun interSteps, args:"; val (cI, ip) = (1, ([3,1], Res));
(**val ((pt, p), tacis) = States.get_calc cI;*)
val ip' = lev_pred' pt ip;

(*+*)ip = ([3, 1], Res);
(*+*)ip' = ([3, 1], Frm);

val ("detailrls", pt, _) = (*case*) Detail_Step.go pt''''' ip (*of*);

Test_Tool.show_pt pt;                  (* added ([3,1,1], Frm), ([3,1,1], Res) after ([3,1], Frm)*)

(* final test ... ----------------------------------------------------------------------------*)
if pr_ctree ctxt pr_short pt =
  ".    ----- pblobj -----\n1" ^
  ".   x + 1 = 2\n" ^
  "2.   x + 1 + - 1 * 2 = 0\n" ^
  "2.1.   x + 1 + - 1 * 2 = 0\n" ^
  "2.2.   1 + x + - 1 * 2 = 0\n" ^
  "2.3.   1 + (x + - 1 * 2) = 0\n" ^
  "2.4.   1 + (x + - 2) = 0\n" ^
  "2.5.   1 + (- 2 + x) = 0\n" ^
  "2.6.   - 2 + (1 + x) = 0\n" ^
  "3.    ----- pblobj -----\n" ^
  "3.1.   - 1 + x = 0\n" ^
  "3.1.1.   - 1 + x = 0\n" ^
(*([3,1,1], Res), x = 0 + - 1 * - 1)       only shown by Test_Tool.show_pt*)
  "3.2.   x = 0 + - 1 * - 1\n" ^(* another difference to Test_Tool.show_pt*)
  "4.   [x = 1]\n"
(*".  [x = 1]"                           only shown by Test_Tool.show_pt*)
then () else error "intermediate steps CHANGED";
